// java wrapper for vtkExtractEnclosedPoints object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtractEnclosedPoints.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPointCloudFilter_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkExtractEnclosedPoints_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkExtractEnclosedPoints",dType)) { return me; }
  if ((res= vtkPointCloudFilter_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractEnclosedPoints_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkExtractEnclosedPoints *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractEnclosedPoints_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkExtractEnclosedPoints *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetSurfaceData_12(JNIEnv *env, jobject obj,jobject id0)
{
  vtkExtractEnclosedPoints *op;
  vtkPolyData  *temp0;
  temp0 = (vtkPolyData *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSurfaceData(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetSurfaceConnection_13(JNIEnv *env, jobject obj,jobject id0)
{
  vtkExtractEnclosedPoints *op;
  vtkAlgorithmOutput  *temp0;
  temp0 = (vtkAlgorithmOutput *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSurfaceConnection(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetSurface_14(JNIEnv *env, jobject obj)
{
  vtkExtractEnclosedPoints *op;
  vtkPolyData  *temp20;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSurface();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetSurface_15(JNIEnv *env, jobject obj,jobject id0)
{
  vtkExtractEnclosedPoints *op;
  vtkInformationVector  *temp0;
  vtkPolyData  *temp20;
  temp0 = (vtkInformationVector *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSurface(temp0);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetCheckSurface_16(JNIEnv *env, jobject obj,jint id0)
{
  vtkExtractEnclosedPoints *op;
  int      temp0;
  temp0 = id0;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  op->SetCheckSurface(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_CheckSurfaceOn_17(JNIEnv *env, jobject obj)
{
  vtkExtractEnclosedPoints *op;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  op->CheckSurfaceOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_CheckSurfaceOff_18(JNIEnv *env, jobject obj)
{
  vtkExtractEnclosedPoints *op;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  op->CheckSurfaceOff();
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetCheckSurface_19(JNIEnv *env, jobject obj)
{
  vtkExtractEnclosedPoints *op;
  int      temp20;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCheckSurface();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetTolerance_110(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkExtractEnclosedPoints *op;
  double   temp0;
  temp0 = id0;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  op->SetTolerance(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetToleranceMinValue_111(JNIEnv *env, jobject obj)
{
  vtkExtractEnclosedPoints *op;
  double   temp20;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetToleranceMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetToleranceMaxValue_112(JNIEnv *env, jobject obj)
{
  vtkExtractEnclosedPoints *op;
  double   temp20;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetToleranceMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetTolerance_113(JNIEnv *env, jobject obj)
{
  vtkExtractEnclosedPoints *op;
  double   temp20;

  op = (vtkExtractEnclosedPoints *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetTolerance();
  return temp20;
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkExtractEnclosedPoints_VTKInit(JNIEnv *, jobject)
{
  vtkExtractEnclosedPoints *aNewOne = vtkExtractEnclosedPoints::New();
  return (jlong)(size_t)(void*)aNewOne;
}
