// java wrapper for vtkGeneralizedKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkGeneralizedKernel.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkInterpolationKernel_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkGeneralizedKernel_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkGeneralizedKernel",dType)) { return me; }
  if ((res= vtkInterpolationKernel_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkGeneralizedKernel *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkGeneralizedKernel *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_ComputeBasis_12(JNIEnv *env, jobject obj,jdoubleArray id0,jobject id1,jint id2)
{
  vtkGeneralizedKernel *op;
  double temp0[3];
  void *tempArray0;
  vtkIdList  *temp1;
  vtkIdType   temp2;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = id2;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ComputeBasis(temp0,temp1,temp2);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_ComputeWeights_13(JNIEnv *env, jobject obj,jdoubleArray id0,jobject id1,jobject id2,jobject id3)
{
  vtkGeneralizedKernel *op;
  double temp0[3];
  void *tempArray0;
  vtkIdList  *temp1;
  vtkDoubleArray  *temp2;
  vtkDoubleArray  *temp3;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkDoubleArray *)(vtkJavaGetPointerFromObject(env,id2));
  temp3 = (vtkDoubleArray *)(vtkJavaGetPointerFromObject(env,id3));

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ComputeWeights(temp0,temp1,temp2,temp3);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_ComputeWeights_14(JNIEnv *env, jobject obj,jdoubleArray id0,jobject id1,jobject id2)
{
  vtkGeneralizedKernel *op;
  double temp0[3];
  void *tempArray0;
  vtkIdList  *temp1;
  vtkDoubleArray  *temp2;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkDoubleArray *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ComputeWeights(temp0,temp1,temp2);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_SetKernelFootprint_15(JNIEnv *env, jobject obj,jint id0)
{
  vtkGeneralizedKernel *op;
  int      temp0;
  temp0 = id0;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetKernelFootprint(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_GetKernelFootprint_16(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  int      temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetKernelFootprint();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_SetKernelFootprintToRadius_17(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetKernelFootprintToRadius();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_SetKernelFootprintToNClosest_18(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetKernelFootprintToNClosest();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_SetRadius_19(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkGeneralizedKernel *op;
  double   temp0;
  temp0 = id0;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetRadius(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGeneralizedKernel_GetRadiusMinValue_110(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  double   temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadiusMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGeneralizedKernel_GetRadiusMaxValue_111(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  double   temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadiusMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGeneralizedKernel_GetRadius_112(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  double   temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadius();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_SetNumberOfPoints_113(JNIEnv *env, jobject obj,jint id0)
{
  vtkGeneralizedKernel *op;
  int      temp0;
  temp0 = id0;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetNumberOfPoints(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_GetNumberOfPointsMinValue_114(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  int      temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfPointsMinValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_GetNumberOfPointsMaxValue_115(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  int      temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfPointsMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGeneralizedKernel_GetNumberOfPoints_116(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  int      temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfPoints();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_SetNormalizeWeights_117(JNIEnv *env, jobject obj,jboolean id0)
{
  vtkGeneralizedKernel *op;
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetNormalizeWeights(temp0);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkGeneralizedKernel_GetNormalizeWeights_118(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;
  bool   temp20;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNormalizeWeights();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_NormalizeWeightsOn_119(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->NormalizeWeightsOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGeneralizedKernel_NormalizeWeightsOff_120(JNIEnv *env, jobject obj)
{
  vtkGeneralizedKernel *op;

  op = (vtkGeneralizedKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->NormalizeWeightsOff();
}
