// java wrapper for vtkSkybox object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSkybox.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkActor_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkSkybox_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkSkybox",dType)) { return me; }
  if ((res= vtkActor_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSkybox_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkSkybox *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSkybox_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkSkybox *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSkybox_GetProjection_12(JNIEnv *env, jobject obj)
{
  vtkSkybox *op;
  int      temp20;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetProjection();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetProjection_13(JNIEnv *env, jobject obj,jint id0)
{
  vtkSkybox *op;
  int      temp0;
  temp0 = id0;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetProjection(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetProjectionToCube_14(JNIEnv *env, jobject obj)
{
  vtkSkybox *op;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetProjectionToCube();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetProjectionToSphere_15(JNIEnv *env, jobject obj)
{
  vtkSkybox *op;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetProjectionToSphere();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetProjectionToFloor_16(JNIEnv *env, jobject obj)
{
  vtkSkybox *op;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetProjectionToFloor();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetFloorPlane_17(JNIEnv *env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jdouble id3)
{
  vtkSkybox *op;
  float    temp0;
  float    temp1;
  float    temp2;
  float    temp3;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFloorPlane(temp0,temp1,temp2,temp3);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetFloorPlane_18(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkSkybox *op;
  float  temp0[4];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp0[3] = ((jdouble *)tempArray0)[3];

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFloorPlane(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  ((jdouble *)tempArray0)[3] = temp0[3];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkSkybox_GetFloorPlane_19(JNIEnv *env, jobject obj)
{
  vtkSkybox *op;
  float   *temp20;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFloorPlane();
    return vtkJavaMakeJArrayOfDoubleFromFloat(env,temp20,4);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetFloorRight_110(JNIEnv *env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  vtkSkybox *op;
  float    temp0;
  float    temp1;
  float    temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFloorRight(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_SetFloorRight_111(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkSkybox *op;
  float  temp0[3];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->SetFloorRight(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkSkybox_GetFloorRight_112(JNIEnv *env, jobject obj)
{
  vtkSkybox *op;
  float   *temp20;

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetFloorRight();
    return vtkJavaMakeJArrayOfDoubleFromFloat(env,temp20,3);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSkybox_GetBounds_113(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkSkybox *op;
  double temp0[6];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp0[3] = ((jdouble *)tempArray0)[3];
  temp0[4] = ((jdouble *)tempArray0)[4];
  temp0[5] = ((jdouble *)tempArray0)[5];

  op = (vtkSkybox *)vtkJavaGetPointerFromObject(env,obj);
  op->GetBounds(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  ((jdouble *)tempArray0)[3] = temp0[3];
  ((jdouble *)tempArray0)[4] = temp0[4];
  ((jdouble *)tempArray0)[5] = temp0[5];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkSkybox_VTKInit(JNIEnv *, jobject)
{
  vtkSkybox *aNewOne = vtkSkybox::New();
  return (jlong)(size_t)(void*)aNewOne;
}
