// python wrapper for vtkAssignCoordinatesLayoutStrategy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkAssignCoordinatesLayoutStrategy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAssignCoordinatesLayoutStrategy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAssignCoordinatesLayoutStrategy_ClassNew(); }

#ifndef DECLARED_PyvtkGraphLayoutStrategy_ClassNew
extern "C" { PyObject *PyvtkGraphLayoutStrategy_ClassNew(); }
#define DECLARED_PyvtkGraphLayoutStrategy_ClassNew
#endif

static const char *PyvtkAssignCoordinatesLayoutStrategy_Doc =
  "vtkAssignCoordinatesLayoutStrategy - uses array values to set vertex\nlocations\n\n"
  "Superclass: vtkGraphLayoutStrategy\n\n"
  "Uses vtkAssignCoordinates to use values from arrays as the x, y, and\n"
  "z coordinates.\n\n";


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkAssignCoordinatesLayoutStrategy::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAssignCoordinatesLayoutStrategy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkAssignCoordinatesLayoutStrategy *tempr = vtkAssignCoordinatesLayoutStrategy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkAssignCoordinatesLayoutStrategy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAssignCoordinatesLayoutStrategy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_SetXCoordArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetXCoordArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetXCoordArrayName(temp0);
    }
    else
    {
      op->vtkAssignCoordinatesLayoutStrategy::SetXCoordArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_GetXCoordArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetXCoordArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetXCoordArrayName() :
      op->vtkAssignCoordinatesLayoutStrategy::GetXCoordArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_SetYCoordArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetYCoordArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetYCoordArrayName(temp0);
    }
    else
    {
      op->vtkAssignCoordinatesLayoutStrategy::SetYCoordArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_GetYCoordArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetYCoordArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetYCoordArrayName() :
      op->vtkAssignCoordinatesLayoutStrategy::GetYCoordArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_SetZCoordArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetZCoordArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetZCoordArrayName(temp0);
    }
    else
    {
      op->vtkAssignCoordinatesLayoutStrategy::SetZCoordArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_GetZCoordArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetZCoordArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetZCoordArrayName() :
      op->vtkAssignCoordinatesLayoutStrategy::GetZCoordArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAssignCoordinatesLayoutStrategy_Layout(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Layout");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAssignCoordinatesLayoutStrategy *op = static_cast<vtkAssignCoordinatesLayoutStrategy *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Layout();
    }
    else
    {
      op->vtkAssignCoordinatesLayoutStrategy::Layout();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkAssignCoordinatesLayoutStrategy_Methods[] = {
  {"IsTypeOf", PyvtkAssignCoordinatesLayoutStrategy_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkAssignCoordinatesLayoutStrategy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkAssignCoordinatesLayoutStrategy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkAssignCoordinatesLayoutStrategy\nC++: static vtkAssignCoordinatesLayoutStrategy *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkAssignCoordinatesLayoutStrategy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAssignCoordinatesLayoutStrategy\nC++: vtkAssignCoordinatesLayoutStrategy *NewInstance()\n\n"},
  {"SetXCoordArrayName", PyvtkAssignCoordinatesLayoutStrategy_SetXCoordArrayName, METH_VARARGS,
   "V.SetXCoordArrayName(string)\nC++: virtual void SetXCoordArrayName(const char *name)\n\nThe array to use for the x coordinate values.\n"},
  {"GetXCoordArrayName", PyvtkAssignCoordinatesLayoutStrategy_GetXCoordArrayName, METH_VARARGS,
   "V.GetXCoordArrayName() -> string\nC++: virtual const char *GetXCoordArrayName()\n\nThe array to use for the x coordinate values.\n"},
  {"SetYCoordArrayName", PyvtkAssignCoordinatesLayoutStrategy_SetYCoordArrayName, METH_VARARGS,
   "V.SetYCoordArrayName(string)\nC++: virtual void SetYCoordArrayName(const char *name)\n\nThe array to use for the y coordinate values.\n"},
  {"GetYCoordArrayName", PyvtkAssignCoordinatesLayoutStrategy_GetYCoordArrayName, METH_VARARGS,
   "V.GetYCoordArrayName() -> string\nC++: virtual const char *GetYCoordArrayName()\n\nThe array to use for the y coordinate values.\n"},
  {"SetZCoordArrayName", PyvtkAssignCoordinatesLayoutStrategy_SetZCoordArrayName, METH_VARARGS,
   "V.SetZCoordArrayName(string)\nC++: virtual void SetZCoordArrayName(const char *name)\n\nThe array to use for the z coordinate values.\n"},
  {"GetZCoordArrayName", PyvtkAssignCoordinatesLayoutStrategy_GetZCoordArrayName, METH_VARARGS,
   "V.GetZCoordArrayName() -> string\nC++: virtual const char *GetZCoordArrayName()\n\nThe array to use for the z coordinate values.\n"},
  {"Layout", PyvtkAssignCoordinatesLayoutStrategy_Layout, METH_VARARGS,
   "V.Layout()\nC++: void Layout() override;\n\nPerform the random layout.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkAssignCoordinatesLayoutStrategy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkAssignCoordinatesLayoutStrategy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkAssignCoordinatesLayoutStrategy_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAssignCoordinatesLayoutStrategy_StaticNew()
{
  return vtkAssignCoordinatesLayoutStrategy::New();
}

PyObject *PyvtkAssignCoordinatesLayoutStrategy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAssignCoordinatesLayoutStrategy_Type, PyvtkAssignCoordinatesLayoutStrategy_Methods,
    "vtkAssignCoordinatesLayoutStrategy",
 &PyvtkAssignCoordinatesLayoutStrategy_StaticNew);

  PyTypeObject *pytype = &PyvtkAssignCoordinatesLayoutStrategy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGraphLayoutStrategy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkAssignCoordinatesLayoutStrategy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAssignCoordinatesLayoutStrategy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAssignCoordinatesLayoutStrategy", o) != 0)
  {
    Py_DECREF(o);
  }

}

