// python wrapper for vtkGeoAlignedImageRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoAlignedImageRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoAlignedImageRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoAlignedImageRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkDataRepresentation_ClassNew
extern "C" { PyObject *PyvtkDataRepresentation_ClassNew(); }
#define DECLARED_PyvtkDataRepresentation_ClassNew
#endif

static const char *PyvtkGeoAlignedImageRepresentation_Doc =
  "vtkGeoAlignedImageRepresentation - A multi-resolution image tree\n\n"
  "Superclass: vtkDataRepresentation\n\n"
  "vtkGeoAlignedImageRepresentation represents a high resolution image\n"
  "over the globle. It has an associated vtkGeoSource which is\n"
  "responsible for fetching new data. This class keeps the fetched data\n"
  "in a quad-tree structure organized by latitude and longitude.\n\n";


static PyObject *
PyvtkGeoAlignedImageRepresentation_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGeoAlignedImageRepresentation::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoAlignedImageRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGeoAlignedImageRepresentation *tempr = vtkGeoAlignedImageRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoAlignedImageRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoAlignedImageRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_GetBestImageForBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBestImageForBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  const size_t size0 = 4;
  double temp0[4];
  double save0[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.Save(temp0, save0, size0);

    vtkGeoImageNode *tempr = (ap.IsBound() ?
      op->GetBestImageForBounds(temp0) :
      op->vtkGeoAlignedImageRepresentation::GetBestImageForBounds(temp0));

    if (ap.HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_GetSource(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSource");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoSource *tempr = (ap.IsBound() ?
      op->GetSource() :
      op->vtkGeoAlignedImageRepresentation::GetSource());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_SetSource(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSource");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  vtkGeoSource *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoSource"))
  {
    if (ap.IsBound())
    {
      op->SetSource(temp0);
    }
    else
    {
      op->vtkGeoAlignedImageRepresentation::SetSource(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAlignedImageRepresentation_SaveDatabase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SaveDatabase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAlignedImageRepresentation *op = static_cast<vtkGeoAlignedImageRepresentation *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SaveDatabase(temp0);
    }
    else
    {
      op->vtkGeoAlignedImageRepresentation::SaveDatabase(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoAlignedImageRepresentation_Methods[] = {
  {"IsTypeOf", PyvtkGeoAlignedImageRepresentation_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGeoAlignedImageRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGeoAlignedImageRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGeoAlignedImageRepresentation\nC++: static vtkGeoAlignedImageRepresentation *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGeoAlignedImageRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoAlignedImageRepresentation\nC++: vtkGeoAlignedImageRepresentation *NewInstance()\n\n"},
  {"GetBestImageForBounds", PyvtkGeoAlignedImageRepresentation_GetBestImageForBounds, METH_VARARGS,
   "V.GetBestImageForBounds([float, float, float, float])\n    -> vtkGeoImageNode\nC++: virtual vtkGeoImageNode *GetBestImageForBounds(\n    double bounds[4])\n\nRetrieve the most refined image patch that covers the specified\nlatitude and longitude bounds (lat-min, lat-max, long-min,\nlong-max).\n"},
  {"GetSource", PyvtkGeoAlignedImageRepresentation_GetSource, METH_VARARGS,
   "V.GetSource() -> vtkGeoSource\nC++: virtual vtkGeoSource *GetSource()\n\nThe source for this representation. This must be set first before\ncalling GetBestImageForBounds.\n"},
  {"SetSource", PyvtkGeoAlignedImageRepresentation_SetSource, METH_VARARGS,
   "V.SetSource(vtkGeoSource)\nC++: virtual void SetSource(vtkGeoSource *source)\n\n"},
  {"SaveDatabase", PyvtkGeoAlignedImageRepresentation_SaveDatabase, METH_VARARGS,
   "V.SaveDatabase(string)\nC++: void SaveDatabase(const char *path)\n\nSerialize the database to the specified directory. Each image is\nstored as a .vti file. The Origin and Spacing of the saved image\ncontain (lat-min, long-min) and (lat-max, long-max),\nrespectively. Files are named based on their level and id within\nthat level.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkGeoAlignedImageRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoAlignedImageRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGeoAlignedImageRepresentation_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoAlignedImageRepresentation_StaticNew()
{
  return vtkGeoAlignedImageRepresentation::New();
}

PyObject *PyvtkGeoAlignedImageRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoAlignedImageRepresentation_Type, PyvtkGeoAlignedImageRepresentation_Methods,
    "vtkGeoAlignedImageRepresentation",
 &PyvtkGeoAlignedImageRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoAlignedImageRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGeoAlignedImageRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoAlignedImageRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoAlignedImageRepresentation", o) != 0)
  {
    Py_DECREF(o);
  }

}

