// python wrapper for vtkGeoInteractorStyle
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoInteractorStyle.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoInteractorStyle(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoInteractorStyle_ClassNew(); }

#ifndef DECLARED_PyvtkInteractorStyleTrackballCamera_ClassNew
extern "C" { PyObject *PyvtkInteractorStyleTrackballCamera_ClassNew(); }
#define DECLARED_PyvtkInteractorStyleTrackballCamera_ClassNew
#endif

static const char *PyvtkGeoInteractorStyle_Doc =
  "vtkGeoInteractorStyle - Interaction for a globe\n\n"
  "Superclass: vtkInteractorStyleTrackballCamera\n\n"
  "vtkGeoInteractorStyle contains interaction capabilities for a\n"
  "geographic view including orbit, zoom, and tilt. It also includes a\n"
  "compass widget for changing view parameters.\n\n"
  "@sa\n"
  "vtkCompassWidget vtkInteractorStyle\n\n";


static PyObject *
PyvtkGeoInteractorStyle_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGeoInteractorStyle::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoInteractorStyle::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGeoInteractorStyle *tempr = vtkGeoInteractorStyle::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoInteractorStyle *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoInteractorStyle::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnEnter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnEnter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnEnter();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnEnter();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnLeave(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnLeave");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnLeave();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnLeave();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnMouseMove(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMouseMove");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnMouseMove();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnMouseMove();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnLeftButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnLeftButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnLeftButtonUp();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnLeftButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnMiddleButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMiddleButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnMiddleButtonUp();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnMiddleButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnRightButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnRightButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnRightButtonUp();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnRightButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnLeftButtonDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnLeftButtonDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnLeftButtonDown();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnLeftButtonDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnMiddleButtonDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMiddleButtonDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnMiddleButtonDown();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnMiddleButtonDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnRightButtonDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnRightButtonDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnRightButtonDown();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnRightButtonDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_OnChar(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnChar");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnChar();
    }
    else
    {
      op->vtkGeoInteractorStyle::OnChar();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_RubberBandZoom(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RubberBandZoom");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RubberBandZoom();
    }
    else
    {
      op->vtkGeoInteractorStyle::RubberBandZoom();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_Pan(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pan");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Pan();
    }
    else
    {
      op->vtkGeoInteractorStyle::Pan();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_Dolly(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Dolly");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Dolly();
    }
    else
    {
      op->vtkGeoInteractorStyle::Dolly();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_RedrawRectangle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RedrawRectangle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RedrawRectangle();
    }
    else
    {
      op->vtkGeoInteractorStyle::RedrawRectangle();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_StartState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->StartState(temp0);
    }
    else
    {
      op->vtkGeoInteractorStyle::StartState(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_GetGeoCamera(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGeoCamera");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoCamera *tempr = (ap.IsBound() ?
      op->GetGeoCamera() :
      op->vtkGeoInteractorStyle::GetGeoCamera());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_ResetCamera(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResetCamera");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ResetCamera();
    }
    else
    {
      op->vtkGeoInteractorStyle::ResetCamera();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_WidgetInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WidgetInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  vtkObject *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    if (ap.IsBound())
    {
      op->WidgetInteraction(temp0);
    }
    else
    {
      op->vtkGeoInteractorStyle::WidgetInteraction(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_SetInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInteractor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  vtkRenderWindowInteractor *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindowInteractor"))
  {
    if (ap.IsBound())
    {
      op->SetInteractor(temp0);
    }
    else
    {
      op->vtkGeoInteractorStyle::SetInteractor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_ViewportToWorld(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ViewportToWorld");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    int tempr = (ap.IsBound() ?
      op->ViewportToWorld(temp0, temp1, temp2, temp3, temp4) :
      op->vtkGeoInteractorStyle::ViewportToWorld(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(2, temp2);
    }
    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(3, temp3);
    }
    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(4, temp4);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_WorldToLongLat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WorldToLongLat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    if (ap.IsBound())
    {
      op->WorldToLongLat(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkGeoInteractorStyle::WorldToLongLat(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(3, temp3);
    }
    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(4, temp4);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_ViewportToLongLat(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ViewportToLongLat");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->ViewportToLongLat(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkGeoInteractorStyle::ViewportToLongLat(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(2, temp2);
    }
    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(3, temp3);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_GetRayIntersection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRayIntersection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  const size_t size0 = 3;
  double temp0[3];
  double save0[3];
  const size_t size1 = 3;
  double temp1[3];
  double save1[3];
  const size_t size2 = 3;
  double temp2[3];
  double save2[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetArray(temp2, size2))
  {
    ap.Save(temp0, save0, size0);
    ap.Save(temp1, save1, size1);
    ap.Save(temp2, save2, size2);

    int tempr = (ap.IsBound() ?
      op->GetRayIntersection(temp0, temp1, temp2) :
      op->vtkGeoInteractorStyle::GetRayIntersection(temp0, temp1, temp2));

    if (ap.HasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (ap.HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (ap.HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_SetCurrentRenderer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCurrentRenderer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  vtkRenderer *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    if (ap.IsBound())
    {
      op->SetCurrentRenderer(temp0);
    }
    else
    {
      op->vtkGeoInteractorStyle::SetCurrentRenderer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_GetLockHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLockHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetLockHeading() :
      op->vtkGeoInteractorStyle::GetLockHeading());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_SetLockHeading(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLockHeading");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLockHeading(temp0);
    }
    else
    {
      op->vtkGeoInteractorStyle::SetLockHeading(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_LockHeadingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockHeadingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LockHeadingOn();
    }
    else
    {
      op->vtkGeoInteractorStyle::LockHeadingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_LockHeadingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "LockHeadingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->LockHeadingOff();
    }
    else
    {
      op->vtkGeoInteractorStyle::LockHeadingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoInteractorStyle_ResetCameraClippingRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResetCameraClippingRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoInteractorStyle *op = static_cast<vtkGeoInteractorStyle *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ResetCameraClippingRange();
    }
    else
    {
      op->vtkGeoInteractorStyle::ResetCameraClippingRange();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoInteractorStyle_Methods[] = {
  {"IsTypeOf", PyvtkGeoInteractorStyle_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGeoInteractorStyle_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGeoInteractorStyle_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGeoInteractorStyle\nC++: static vtkGeoInteractorStyle *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGeoInteractorStyle_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoInteractorStyle\nC++: vtkGeoInteractorStyle *NewInstance()\n\n"},
  {"OnEnter", PyvtkGeoInteractorStyle_OnEnter, METH_VARARGS,
   "V.OnEnter()\nC++: void OnEnter() override;\n\nEvent bindings\n"},
  {"OnLeave", PyvtkGeoInteractorStyle_OnLeave, METH_VARARGS,
   "V.OnLeave()\nC++: void OnLeave() override;\n\nEvent bindings\n"},
  {"OnMouseMove", PyvtkGeoInteractorStyle_OnMouseMove, METH_VARARGS,
   "V.OnMouseMove()\nC++: void OnMouseMove() override;\n\nEvent bindings\n"},
  {"OnLeftButtonUp", PyvtkGeoInteractorStyle_OnLeftButtonUp, METH_VARARGS,
   "V.OnLeftButtonUp()\nC++: void OnLeftButtonUp() override;\n\nEvent bindings\n"},
  {"OnMiddleButtonUp", PyvtkGeoInteractorStyle_OnMiddleButtonUp, METH_VARARGS,
   "V.OnMiddleButtonUp()\nC++: void OnMiddleButtonUp() override;\n\nEvent bindings\n"},
  {"OnRightButtonUp", PyvtkGeoInteractorStyle_OnRightButtonUp, METH_VARARGS,
   "V.OnRightButtonUp()\nC++: void OnRightButtonUp() override;\n\nEvent bindings\n"},
  {"OnLeftButtonDown", PyvtkGeoInteractorStyle_OnLeftButtonDown, METH_VARARGS,
   "V.OnLeftButtonDown()\nC++: void OnLeftButtonDown() override;\n\nEvent bindings\n"},
  {"OnMiddleButtonDown", PyvtkGeoInteractorStyle_OnMiddleButtonDown, METH_VARARGS,
   "V.OnMiddleButtonDown()\nC++: void OnMiddleButtonDown() override;\n\nEvent bindings\n"},
  {"OnRightButtonDown", PyvtkGeoInteractorStyle_OnRightButtonDown, METH_VARARGS,
   "V.OnRightButtonDown()\nC++: void OnRightButtonDown() override;\n\nEvent bindings\n"},
  {"OnChar", PyvtkGeoInteractorStyle_OnChar, METH_VARARGS,
   "V.OnChar()\nC++: void OnChar() override;\n\nEvent bindings\n"},
  {"RubberBandZoom", PyvtkGeoInteractorStyle_RubberBandZoom, METH_VARARGS,
   "V.RubberBandZoom()\nC++: virtual void RubberBandZoom()\n\n"},
  {"Pan", PyvtkGeoInteractorStyle_Pan, METH_VARARGS,
   "V.Pan()\nC++: void Pan() override;\n\n"},
  {"Dolly", PyvtkGeoInteractorStyle_Dolly, METH_VARARGS,
   "V.Dolly()\nC++: void Dolly() override;\n\n"},
  {"RedrawRectangle", PyvtkGeoInteractorStyle_RedrawRectangle, METH_VARARGS,
   "V.RedrawRectangle()\nC++: void RedrawRectangle()\n\n"},
  {"StartState", PyvtkGeoInteractorStyle_StartState, METH_VARARGS,
   "V.StartState(int)\nC++: void StartState(int newstate) override;\n\nutility routines used by state changes\n"},
  {"GetGeoCamera", PyvtkGeoInteractorStyle_GetGeoCamera, METH_VARARGS,
   "V.GetGeoCamera() -> vtkGeoCamera\nC++: vtkGeoCamera *GetGeoCamera()\n\n"},
  {"ResetCamera", PyvtkGeoInteractorStyle_ResetCamera, METH_VARARGS,
   "V.ResetCamera()\nC++: void ResetCamera()\n\nThis can be used to set the camera to the standard view of the\nearth.\n"},
  {"WidgetInteraction", PyvtkGeoInteractorStyle_WidgetInteraction, METH_VARARGS,
   "V.WidgetInteraction(vtkObject)\nC++: void WidgetInteraction(vtkObject *caller)\n\nCalled when the sub widgets have an interaction\n"},
  {"SetInteractor", PyvtkGeoInteractorStyle_SetInteractor, METH_VARARGS,
   "V.SetInteractor(vtkRenderWindowInteractor)\nC++: void SetInteractor(vtkRenderWindowInteractor *interactor)\n    override;\n\nSet/Get the Interactor wrapper being controlled by this object.\n(Satisfy superclass API.)\n"},
  {"ViewportToWorld", PyvtkGeoInteractorStyle_ViewportToWorld, METH_VARARGS,
   "V.ViewportToWorld(float, float, float, float, float) -> int\nC++: int ViewportToWorld(double x, double y, double &wx,\n    double &wy, double &wz)\n\n"},
  {"WorldToLongLat", PyvtkGeoInteractorStyle_WorldToLongLat, METH_VARARGS,
   "V.WorldToLongLat(float, float, float, float, float)\nC++: void WorldToLongLat(double wx, double wy, double wz,\n    double &lon, double &lat)\n\n"},
  {"ViewportToLongLat", PyvtkGeoInteractorStyle_ViewportToLongLat, METH_VARARGS,
   "V.ViewportToLongLat(float, float, float, float)\nC++: void ViewportToLongLat(double x, double y, double &lon,\n    double &lat)\n\n"},
  {"GetRayIntersection", PyvtkGeoInteractorStyle_GetRayIntersection, METH_VARARGS,
   "V.GetRayIntersection([float, float, float], [float, float, float],\n     [float, float, float]) -> int\nC++: int GetRayIntersection(double origin[3], double direction[3],\n     double intersection[3])\n\n"},
  {"SetCurrentRenderer", PyvtkGeoInteractorStyle_SetCurrentRenderer, METH_VARARGS,
   "V.SetCurrentRenderer(vtkRenderer)\nC++: void SetCurrentRenderer(vtkRenderer *) override;\n\nOverride to make the renderer use this camera subclass\n"},
  {"GetLockHeading", PyvtkGeoInteractorStyle_GetLockHeading, METH_VARARGS,
   "V.GetLockHeading() -> bool\nC++: virtual bool GetLockHeading()\n\nWhether to lock the heading a particular value during pan.\n"},
  {"SetLockHeading", PyvtkGeoInteractorStyle_SetLockHeading, METH_VARARGS,
   "V.SetLockHeading(bool)\nC++: virtual void SetLockHeading(bool _arg)\n\nWhether to lock the heading a particular value during pan.\n"},
  {"LockHeadingOn", PyvtkGeoInteractorStyle_LockHeadingOn, METH_VARARGS,
   "V.LockHeadingOn()\nC++: virtual void LockHeadingOn()\n\nWhether to lock the heading a particular value during pan.\n"},
  {"LockHeadingOff", PyvtkGeoInteractorStyle_LockHeadingOff, METH_VARARGS,
   "V.LockHeadingOff()\nC++: virtual void LockHeadingOff()\n\nWhether to lock the heading a particular value during pan.\n"},
  {"ResetCameraClippingRange", PyvtkGeoInteractorStyle_ResetCameraClippingRange, METH_VARARGS,
   "V.ResetCameraClippingRange()\nC++: void ResetCameraClippingRange()\n\nCalled after camera properties are modified\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkGeoInteractorStyle_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoInteractorStyle", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGeoInteractorStyle_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoInteractorStyle_StaticNew()
{
  return vtkGeoInteractorStyle::New();
}

PyObject *PyvtkGeoInteractorStyle_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoInteractorStyle_Type, PyvtkGeoInteractorStyle_Methods,
    "vtkGeoInteractorStyle",
 &PyvtkGeoInteractorStyle_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoInteractorStyle_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkInteractorStyleTrackballCamera_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGeoInteractorStyle(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoInteractorStyle_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoInteractorStyle", o) != 0)
  {
    Py_DECREF(o);
  }

}

