// python wrapper for vtkGeoProjectionSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoProjectionSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoProjectionSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoProjectionSource_ClassNew(); }

#ifndef DECLARED_PyvtkGeoSource_ClassNew
extern "C" { PyObject *PyvtkGeoSource_ClassNew(); }
#define DECLARED_PyvtkGeoSource_ClassNew
#endif

static const char *PyvtkGeoProjectionSource_Doc =
  "vtkGeoProjectionSource - A 2D geographic geometry source\n\n"
  "Superclass: vtkGeoSource\n\n"
  "vtkGeoProjectionSource is a vtkGeoSource suitable for use in\n"
  "vtkTerrain2D. This source uses the libproj library to produce\n"
  "geometry patches at multiple resolutions. Each patch covers a\n"
  "specific region in projected space.\n\n";


static PyObject *
PyvtkGeoProjectionSource_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGeoProjectionSource::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoProjectionSource::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGeoProjectionSource *tempr = vtkGeoProjectionSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoProjectionSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoProjectionSource::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_FetchRoot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FetchRoot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    bool tempr = (ap.IsBound() ?
      op->FetchRoot(temp0) :
      op->vtkGeoProjectionSource::FetchRoot(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_FetchChild(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FetchChild");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  int temp1;
  vtkGeoTreeNode *temp2 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkGeoTreeNode"))
  {
    bool tempr = (ap.IsBound() ?
      op->FetchChild(temp0, temp1, temp2) :
      op->vtkGeoProjectionSource::FetchChild(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_GetProjection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProjection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetProjection() :
      op->vtkGeoProjectionSource::GetProjection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_SetProjection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProjection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetProjection(temp0);
    }
    else
    {
      op->vtkGeoProjectionSource::SetProjection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_GetMinCellsPerNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinCellsPerNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMinCellsPerNode() :
      op->vtkGeoProjectionSource::GetMinCellsPerNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_SetMinCellsPerNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinCellsPerNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMinCellsPerNode(temp0);
    }
    else
    {
      op->vtkGeoProjectionSource::SetMinCellsPerNode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoProjectionSource_GetTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoProjectionSource *op = static_cast<vtkGeoProjectionSource *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkAbstractTransform *tempr = (ap.IsBound() ?
      op->GetTransform() :
      op->vtkGeoProjectionSource::GetTransform());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoProjectionSource_Methods[] = {
  {"IsTypeOf", PyvtkGeoProjectionSource_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGeoProjectionSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGeoProjectionSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGeoProjectionSource\nC++: static vtkGeoProjectionSource *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGeoProjectionSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoProjectionSource\nC++: vtkGeoProjectionSource *NewInstance()\n\n"},
  {"FetchRoot", PyvtkGeoProjectionSource_FetchRoot, METH_VARARGS,
   "V.FetchRoot(vtkGeoTreeNode) -> bool\nC++: bool FetchRoot(vtkGeoTreeNode *root) override;\n\nBlocking methods for sources with low latency.\n"},
  {"FetchChild", PyvtkGeoProjectionSource_FetchChild, METH_VARARGS,
   "V.FetchChild(vtkGeoTreeNode, int, vtkGeoTreeNode) -> bool\nC++: bool FetchChild(vtkGeoTreeNode *node, int index,\n    vtkGeoTreeNode *child) override;\n\nBlocking methods for sources with low latency.\n"},
  {"GetProjection", PyvtkGeoProjectionSource_GetProjection, METH_VARARGS,
   "V.GetProjection() -> int\nC++: virtual int GetProjection()\n\nThe projection ID defining the projection. Initial value is 0.\n"},
  {"SetProjection", PyvtkGeoProjectionSource_SetProjection, METH_VARARGS,
   "V.SetProjection(int)\nC++: virtual void SetProjection(int projection)\n\nThe projection ID defining the projection. Initial value is 0.\n"},
  {"GetMinCellsPerNode", PyvtkGeoProjectionSource_GetMinCellsPerNode, METH_VARARGS,
   "V.GetMinCellsPerNode() -> int\nC++: virtual int GetMinCellsPerNode()\n\nThe minimum number of cells per node.\n"},
  {"SetMinCellsPerNode", PyvtkGeoProjectionSource_SetMinCellsPerNode, METH_VARARGS,
   "V.SetMinCellsPerNode(int)\nC++: virtual void SetMinCellsPerNode(int _arg)\n\nThe minimum number of cells per node.\n"},
  {"GetTransform", PyvtkGeoProjectionSource_GetTransform, METH_VARARGS,
   "V.GetTransform() -> vtkAbstractTransform\nC++: vtkAbstractTransform *GetTransform() override;\n\nReturn the projection transformation used by this 2D terrain.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkGeoProjectionSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoProjectionSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGeoProjectionSource_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoProjectionSource_StaticNew()
{
  return vtkGeoProjectionSource::New();
}

PyObject *PyvtkGeoProjectionSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoProjectionSource_Type, PyvtkGeoProjectionSource_Methods,
    "vtkGeoProjectionSource",
 &PyvtkGeoProjectionSource_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoProjectionSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGeoSource_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGeoProjectionSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoProjectionSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoProjectionSource", o) != 0)
  {
    Py_DECREF(o);
  }

}

