// python wrapper for vtkImplicitFunctionToImageStencil
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkImplicitFunctionToImageStencil.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImplicitFunctionToImageStencil(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImplicitFunctionToImageStencil_ClassNew(); }

#ifndef DECLARED_PyvtkImageStencilSource_ClassNew
extern "C" { PyObject *PyvtkImageStencilSource_ClassNew(); }
#define DECLARED_PyvtkImageStencilSource_ClassNew
#endif

static const char *PyvtkImplicitFunctionToImageStencil_Doc =
  "vtkImplicitFunctionToImageStencil - clip an image with a function\n\n"
  "Superclass: vtkImageStencilSource\n\n"
  "vtkImplicitFunctionToImageStencil will convert a vtkImplicitFunction\n"
  "into a stencil that can be used with vtkImageStencil or with other\n"
  "classes that apply a stencil to an image.\n"
  "@sa\n"
  "vtkImplicitFunction vtkImageStencil vtkPolyDataToImageStencil\n\n";


static PyObject *
PyvtkImplicitFunctionToImageStencil_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImplicitFunctionToImageStencil::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionToImageStencil *op = static_cast<vtkImplicitFunctionToImageStencil *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImplicitFunctionToImageStencil::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkImplicitFunctionToImageStencil *tempr = vtkImplicitFunctionToImageStencil::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionToImageStencil *op = static_cast<vtkImplicitFunctionToImageStencil *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImplicitFunctionToImageStencil *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImplicitFunctionToImageStencil::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_SetInput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionToImageStencil *op = static_cast<vtkImplicitFunctionToImageStencil *>(vp);

  vtkImplicitFunction *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImplicitFunction"))
  {
    if (ap.IsBound())
    {
      op->SetInput(temp0);
    }
    else
    {
      op->vtkImplicitFunctionToImageStencil::SetInput(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_GetInput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionToImageStencil *op = static_cast<vtkImplicitFunctionToImageStencil *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkImplicitFunction *tempr = (ap.IsBound() ?
      op->GetInput() :
      op->vtkImplicitFunctionToImageStencil::GetInput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_SetThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionToImageStencil *op = static_cast<vtkImplicitFunctionToImageStencil *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetThreshold(temp0);
    }
    else
    {
      op->vtkImplicitFunctionToImageStencil::SetThreshold(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_GetThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionToImageStencil *op = static_cast<vtkImplicitFunctionToImageStencil *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetThreshold() :
      op->vtkImplicitFunctionToImageStencil::GetThreshold());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImplicitFunctionToImageStencil_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImplicitFunctionToImageStencil *op = static_cast<vtkImplicitFunctionToImageStencil *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkImplicitFunctionToImageStencil::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkImplicitFunctionToImageStencil_Methods[] = {
  {"IsTypeOf", PyvtkImplicitFunctionToImageStencil_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkImplicitFunctionToImageStencil_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkImplicitFunctionToImageStencil_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkImplicitFunctionToImageStencil\nC++: static vtkImplicitFunctionToImageStencil *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkImplicitFunctionToImageStencil_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImplicitFunctionToImageStencil\nC++: vtkImplicitFunctionToImageStencil *NewInstance()\n\n"},
  {"SetInput", PyvtkImplicitFunctionToImageStencil_SetInput, METH_VARARGS,
   "V.SetInput(vtkImplicitFunction)\nC++: virtual void SetInput(vtkImplicitFunction *)\n\nSpecify the implicit function to convert into a stencil.\n"},
  {"GetInput", PyvtkImplicitFunctionToImageStencil_GetInput, METH_VARARGS,
   "V.GetInput() -> vtkImplicitFunction\nC++: virtual vtkImplicitFunction *GetInput()\n\nSpecify the implicit function to convert into a stencil.\n"},
  {"SetThreshold", PyvtkImplicitFunctionToImageStencil_SetThreshold, METH_VARARGS,
   "V.SetThreshold(float)\nC++: virtual void SetThreshold(double _arg)\n\nSet the threshold value for the implicit function.\n"},
  {"GetThreshold", PyvtkImplicitFunctionToImageStencil_GetThreshold, METH_VARARGS,
   "V.GetThreshold() -> float\nC++: virtual double GetThreshold()\n\nSet the threshold value for the implicit function.\n"},
  {"GetMTime", PyvtkImplicitFunctionToImageStencil_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: vtkMTimeType GetMTime() override;\n\nOverride GetMTime() to account for the implicit function.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkImplicitFunctionToImageStencil_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingStencilPython.vtkImplicitFunctionToImageStencil", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkImplicitFunctionToImageStencil_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImplicitFunctionToImageStencil_StaticNew()
{
  return vtkImplicitFunctionToImageStencil::New();
}

PyObject *PyvtkImplicitFunctionToImageStencil_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImplicitFunctionToImageStencil_Type, PyvtkImplicitFunctionToImageStencil_Methods,
    "vtkImplicitFunctionToImageStencil",
 &PyvtkImplicitFunctionToImageStencil_StaticNew);

  PyTypeObject *pytype = &PyvtkImplicitFunctionToImageStencil_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageStencilSource_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkImplicitFunctionToImageStencil(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImplicitFunctionToImageStencil_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImplicitFunctionToImageStencil", o) != 0)
  {
    Py_DECREF(o);
  }

}

