// python wrapper for vtkOpenGLUniforms
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkOpenGLUniforms.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOpenGLUniforms(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkOpenGLUniforms_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char *PyvtkOpenGLUniforms_Doc =
  "vtkOpenGLUniforms - no description provided.\n\n"
  "Superclass: vtkObject\n\n"
;


static PyObject *
PyvtkOpenGLUniforms_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOpenGLUniforms::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOpenGLUniforms::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOpenGLUniforms *tempr = vtkOpenGLUniforms::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkOpenGLUniforms *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOpenGLUniforms::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_GetDeclarations(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDeclarations");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetDeclarations() :
      op->vtkOpenGLUniforms::GetDeclarations());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniforms(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniforms");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  vtkShaderProgram *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkShaderProgram"))
  {
    bool tempr = (ap.IsBound() ?
      op->SetUniforms(temp0) :
      op->vtkOpenGLUniforms::SetUniforms(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_GetUniformListMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUniformListMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetUniformListMTime() :
      op->vtkOpenGLUniforms::GetUniformListMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniformi(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniformi");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddUniformi(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniformi(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniformf(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniformf");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  float temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->AddUniformf(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniformf(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform2i(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform2i");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 2;
  int temp1[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->AddUniform2i(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform2i(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform2f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform2f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 2;
  float temp1[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->AddUniform2f(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform2f(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform3f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform3f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 3;
  double temp1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->AddUniform3f(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform3f(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform4f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform4f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 4;
  float temp1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->AddUniform4f(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform4f(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform3uc(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform3uc");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 3;
  unsigned char temp1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->AddUniform3uc(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform3uc(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform4uc(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform4uc");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 4;
  unsigned char temp1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->AddUniform4uc(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform4uc(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniformMatrix_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniformMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  vtkMatrix3x3 *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMatrix3x3"))
  {
    if (ap.IsBound())
    {
      op->AddUniformMatrix(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniformMatrix(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkOpenGLUniforms_AddUniformMatrix_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniformMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  vtkMatrix4x4 *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->AddUniformMatrix(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniformMatrix(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLUniforms_AddUniformMatrix_Methods[] = {
  {nullptr, PyvtkOpenGLUniforms_AddUniformMatrix_s1, METH_VARARGS,
   "@zV *vtkMatrix3x3"},
  {nullptr, PyvtkOpenGLUniforms_AddUniformMatrix_s2, METH_VARARGS,
   "@zV *vtkMatrix4x4"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkOpenGLUniforms_AddUniformMatrix(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkOpenGLUniforms_AddUniformMatrix_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddUniformMatrix");
  return nullptr;
}



static PyObject *
PyvtkOpenGLUniforms_AddUniformMatrix3x3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniformMatrix3x3");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<float> store1(2*size1);
  float *temp1 = store1.Data();
  float *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->AddUniformMatrix3x3(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniformMatrix3x3(temp0, temp1);
    }

    if (ap.HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniformMatrix4x4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniformMatrix4x4");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<float> store1(2*size1);
  float *temp1 = store1.Data();
  float *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->AddUniformMatrix4x4(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniformMatrix4x4(temp0, temp1);
    }

    if (ap.HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform1iv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform1iv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<int> store2(size2);
  int *temp2 = store2.Data();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    if (ap.IsBound())
    {
      op->AddUniform1iv(temp0, temp1, temp2);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform1iv(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniform1fv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniform1fv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<float> store2(size2);
  float *temp2 = store2.Data();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    if (ap.IsBound())
    {
      op->AddUniform1fv(temp0, temp1, temp2);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniform1fv(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_AddUniformMatrix4x4v(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniformMatrix4x4v");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<float> store2(2*size2);
  float *temp2 = store2.Data();
  float *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    ap.Save(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->AddUniformMatrix4x4v(temp0, temp1, temp2);
    }
    else
    {
      op->vtkOpenGLUniforms::AddUniformMatrix4x4v(temp0, temp1, temp2);
    }

    if (ap.HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_RemoveUniform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveUniform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveUniform(temp0);
    }
    else
    {
      op->vtkOpenGLUniforms::RemoveUniform(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_RemoveAllUniforms(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllUniforms");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllUniforms();
    }
    else
    {
      op->vtkOpenGLUniforms::RemoveAllUniforms();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniformi(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformi");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetUniformi(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniformi(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniformf(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformf");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  float temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetUniformf(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniformf(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform2i(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform2i");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 2;
  int temp1[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetUniform2i(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform2i(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform2f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform2f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 2;
  float temp1[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetUniform2f(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform2f(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform3f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform3f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 3;
  double temp1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetUniform3f(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform3f(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform4f(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform4f");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 4;
  float temp1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetUniform4f(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform4f(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform3uc(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform3uc");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 3;
  unsigned char temp1[3];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetUniform3uc(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform3uc(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform4uc(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform4uc");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  const size_t size1 = 4;
  unsigned char temp1[4];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetUniform4uc(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform4uc(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniformMatrix_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  vtkMatrix3x3 *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMatrix3x3"))
  {
    if (ap.IsBound())
    {
      op->SetUniformMatrix(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniformMatrix(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkOpenGLUniforms_SetUniformMatrix_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  vtkMatrix4x4 *temp1 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkMatrix4x4"))
  {
    if (ap.IsBound())
    {
      op->SetUniformMatrix(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniformMatrix(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLUniforms_SetUniformMatrix_Methods[] = {
  {nullptr, PyvtkOpenGLUniforms_SetUniformMatrix_s1, METH_VARARGS,
   "@zV *vtkMatrix3x3"},
  {nullptr, PyvtkOpenGLUniforms_SetUniformMatrix_s2, METH_VARARGS,
   "@zV *vtkMatrix4x4"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkOpenGLUniforms_SetUniformMatrix(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkOpenGLUniforms_SetUniformMatrix_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetUniformMatrix");
  return nullptr;
}



static PyObject *
PyvtkOpenGLUniforms_SetUniformMatrix3x3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix3x3");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<float> store1(2*size1);
  float *temp1 = store1.Data();
  float *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetUniformMatrix3x3(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniformMatrix3x3(temp0, temp1);
    }

    if (ap.HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniformMatrix4x4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix4x4");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<float> store1(2*size1);
  float *temp1 = store1.Data();
  float *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->SetUniformMatrix4x4(temp0, temp1);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniformMatrix4x4(temp0, temp1);
    }

    if (ap.HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform1iv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform1iv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<int> store2(size2);
  int *temp2 = store2.Data();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    if (ap.IsBound())
    {
      op->SetUniform1iv(temp0, temp1, temp2);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform1iv(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniform1fv(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniform1fv");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<float> store2(size2);
  float *temp2 = store2.Data();
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    if (ap.IsBound())
    {
      op->SetUniform1fv(temp0, temp1, temp2);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniform1fv(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOpenGLUniforms_SetUniformMatrix4x4v(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformMatrix4x4v");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOpenGLUniforms *op = static_cast<vtkOpenGLUniforms *>(vp);

  const char *temp0 = nullptr;
  int temp1;
  size_t size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<float> store2(2*size2);
  float *temp2 = store2.Data();
  float *save2 = (size2 == 0 ? nullptr : temp2 + size2);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    ap.Save(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->SetUniformMatrix4x4v(temp0, temp1, temp2);
    }
    else
    {
      op->vtkOpenGLUniforms::SetUniformMatrix4x4v(temp0, temp1, temp2);
    }

    if (ap.HasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOpenGLUniforms_Methods[] = {
  {"IsTypeOf", PyvtkOpenGLUniforms_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkOpenGLUniforms_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkOpenGLUniforms_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOpenGLUniforms\nC++: static vtkOpenGLUniforms *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOpenGLUniforms_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOpenGLUniforms\nC++: vtkOpenGLUniforms *NewInstance()\n\n"},
  {"GetDeclarations", PyvtkOpenGLUniforms_GetDeclarations, METH_VARARGS,
   "V.GetDeclarations() -> string\nC++: std::string GetDeclarations()\n\n"},
  {"SetUniforms", PyvtkOpenGLUniforms_SetUniforms, METH_VARARGS,
   "V.SetUniforms(vtkShaderProgram) -> bool\nC++: bool SetUniforms(vtkShaderProgram *p)\n\n"},
  {"GetUniformListMTime", PyvtkOpenGLUniforms_GetUniformListMTime, METH_VARARGS,
   "V.GetUniformListMTime() -> int\nC++: vtkMTimeType GetUniformListMTime()\n\n"},
  {"AddUniformi", PyvtkOpenGLUniforms_AddUniformi, METH_VARARGS,
   "V.AddUniformi(string, int)\nC++: void AddUniformi(const char *name, int defaultValue)\n\nAdd the name uniform variable with value defaultValue.\n"},
  {"AddUniformf", PyvtkOpenGLUniforms_AddUniformf, METH_VARARGS,
   "V.AddUniformf(string, float)\nC++: void AddUniformf(const char *name, float defaultValue)\n\n"},
  {"AddUniform2i", PyvtkOpenGLUniforms_AddUniform2i, METH_VARARGS,
   "V.AddUniform2i(string, (int, int))\nC++: void AddUniform2i(const char *name,\n    const int defaultValue[2])\n\n"},
  {"AddUniform2f", PyvtkOpenGLUniforms_AddUniform2f, METH_VARARGS,
   "V.AddUniform2f(string, (float, float))\nC++: void AddUniform2f(const char *name,\n    const float defaultValue[2])\n\n"},
  {"AddUniform3f", PyvtkOpenGLUniforms_AddUniform3f, METH_VARARGS,
   "V.AddUniform3f(string, (float, float, float))\nC++: void AddUniform3f(const char *name,\n    const double defaultValue[3])\n\n"},
  {"AddUniform4f", PyvtkOpenGLUniforms_AddUniform4f, METH_VARARGS,
   "V.AddUniform4f(string, (float, float, float, float))\nC++: void AddUniform4f(const char *name,\n    const float defaultValue[4])\n\n"},
  {"AddUniform3uc", PyvtkOpenGLUniforms_AddUniform3uc, METH_VARARGS,
   "V.AddUniform3uc(string, (int, int, int))\nC++: void AddUniform3uc(const char *name,\n    const unsigned char defaultValue[3])\n\n"},
  {"AddUniform4uc", PyvtkOpenGLUniforms_AddUniform4uc, METH_VARARGS,
   "V.AddUniform4uc(string, (int, int, int, int))\nC++: void AddUniform4uc(const char *name,\n    const unsigned char defaultValue[4])\n\n"},
  {"AddUniformMatrix", PyvtkOpenGLUniforms_AddUniformMatrix, METH_VARARGS,
   "V.AddUniformMatrix(string, vtkMatrix3x3)\nC++: void AddUniformMatrix(const char *name,\n    vtkMatrix3x3 *defaultValue)\nV.AddUniformMatrix(string, vtkMatrix4x4)\nC++: void AddUniformMatrix(const char *name,\n    vtkMatrix4x4 *defaultValue)\n\n"},
  {"AddUniformMatrix3x3", PyvtkOpenGLUniforms_AddUniformMatrix3x3, METH_VARARGS,
   "V.AddUniformMatrix3x3(string, [float, ...])\nC++: void AddUniformMatrix3x3(const char *name,\n    float *defaultValue)\n\n"},
  {"AddUniformMatrix4x4", PyvtkOpenGLUniforms_AddUniformMatrix4x4, METH_VARARGS,
   "V.AddUniformMatrix4x4(string, [float, ...])\nC++: void AddUniformMatrix4x4(const char *name,\n    float *defaultValue)\n\n"},
  {"AddUniform1iv", PyvtkOpenGLUniforms_AddUniform1iv, METH_VARARGS,
   "V.AddUniform1iv(string, int, (int, ...))\nC++: void AddUniform1iv(const char *name, const int count,\n    const int *f)\n\nAdd the name uniform array to f with count elements\n"},
  {"AddUniform1fv", PyvtkOpenGLUniforms_AddUniform1fv, METH_VARARGS,
   "V.AddUniform1fv(string, int, (float, ...))\nC++: void AddUniform1fv(const char *name, const int count,\n    const float *f)\n\n"},
  {"AddUniformMatrix4x4v", PyvtkOpenGLUniforms_AddUniformMatrix4x4v, METH_VARARGS,
   "V.AddUniformMatrix4x4v(string, int, [float, ...])\nC++: void AddUniformMatrix4x4v(const char *name, const int count,\n    float *v)\n\n"},
  {"RemoveUniform", PyvtkOpenGLUniforms_RemoveUniform, METH_VARARGS,
   "V.RemoveUniform(string)\nC++: void RemoveUniform(const char *name)\n\nRemove uniform variable named name\n"},
  {"RemoveAllUniforms", PyvtkOpenGLUniforms_RemoveAllUniforms, METH_VARARGS,
   "V.RemoveAllUniforms()\nC++: void RemoveAllUniforms()\n\nRemove all uniform variables\n"},
  {"SetUniformi", PyvtkOpenGLUniforms_SetUniformi, METH_VARARGS,
   "V.SetUniformi(string, int)\nC++: void SetUniformi(const char *name, int v)\n\nSet the name uniform value to v.\n"},
  {"SetUniformf", PyvtkOpenGLUniforms_SetUniformf, METH_VARARGS,
   "V.SetUniformf(string, float)\nC++: void SetUniformf(const char *name, float v)\n\n"},
  {"SetUniform2i", PyvtkOpenGLUniforms_SetUniform2i, METH_VARARGS,
   "V.SetUniform2i(string, (int, int))\nC++: void SetUniform2i(const char *name, const int v[2])\n\n"},
  {"SetUniform2f", PyvtkOpenGLUniforms_SetUniform2f, METH_VARARGS,
   "V.SetUniform2f(string, (float, float))\nC++: void SetUniform2f(const char *name, const float v[2])\n\n"},
  {"SetUniform3f", PyvtkOpenGLUniforms_SetUniform3f, METH_VARARGS,
   "V.SetUniform3f(string, (float, float, float))\nC++: void SetUniform3f(const char *name, const double v[3])\n\n"},
  {"SetUniform4f", PyvtkOpenGLUniforms_SetUniform4f, METH_VARARGS,
   "V.SetUniform4f(string, (float, float, float, float))\nC++: void SetUniform4f(const char *name, const float v[4])\n\n"},
  {"SetUniform3uc", PyvtkOpenGLUniforms_SetUniform3uc, METH_VARARGS,
   "V.SetUniform3uc(string, (int, int, int))\nC++: void SetUniform3uc(const char *name,\n    const unsigned char v[3])\n\n"},
  {"SetUniform4uc", PyvtkOpenGLUniforms_SetUniform4uc, METH_VARARGS,
   "V.SetUniform4uc(string, (int, int, int, int))\nC++: void SetUniform4uc(const char *name,\n    const unsigned char v[4])\n\n"},
  {"SetUniformMatrix", PyvtkOpenGLUniforms_SetUniformMatrix, METH_VARARGS,
   "V.SetUniformMatrix(string, vtkMatrix3x3)\nC++: void SetUniformMatrix(const char *name, vtkMatrix3x3 *v)\nV.SetUniformMatrix(string, vtkMatrix4x4)\nC++: void SetUniformMatrix(const char *name, vtkMatrix4x4 *v)\n\n"},
  {"SetUniformMatrix3x3", PyvtkOpenGLUniforms_SetUniformMatrix3x3, METH_VARARGS,
   "V.SetUniformMatrix3x3(string, [float, ...])\nC++: void SetUniformMatrix3x3(const char *name, float *v)\n\n"},
  {"SetUniformMatrix4x4", PyvtkOpenGLUniforms_SetUniformMatrix4x4, METH_VARARGS,
   "V.SetUniformMatrix4x4(string, [float, ...])\nC++: void SetUniformMatrix4x4(const char *name, float *v)\n\n"},
  {"SetUniform1iv", PyvtkOpenGLUniforms_SetUniform1iv, METH_VARARGS,
   "V.SetUniform1iv(string, int, (int, ...))\nC++: void SetUniform1iv(const char *name, const int count,\n    const int *f)\n\nSet the name uniform array to f with count elements\n"},
  {"SetUniform1fv", PyvtkOpenGLUniforms_SetUniform1fv, METH_VARARGS,
   "V.SetUniform1fv(string, int, (float, ...))\nC++: void SetUniform1fv(const char *name, const int count,\n    const float *f)\n\n"},
  {"SetUniformMatrix4x4v", PyvtkOpenGLUniforms_SetUniformMatrix4x4v, METH_VARARGS,
   "V.SetUniformMatrix4x4v(string, int, [float, ...])\nC++: void SetUniformMatrix4x4v(const char *name, const int count,\n    float *v)\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkOpenGLUniforms_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumeOpenGL2Python.vtkOpenGLUniforms", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkOpenGLUniforms_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOpenGLUniforms_StaticNew()
{
  return vtkOpenGLUniforms::New();
}

PyObject *PyvtkOpenGLUniforms_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkOpenGLUniforms_Type, PyvtkOpenGLUniforms_Methods,
    "vtkOpenGLUniforms",
 &PyvtkOpenGLUniforms_StaticNew);

  PyTypeObject *pytype = &PyvtkOpenGLUniforms_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkOpenGLUniforms(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOpenGLUniforms_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOpenGLUniforms", o) != 0)
  {
    Py_DECREF(o);
  }

}

