// python wrapper for vtkPerturbCoincidentVertices
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPerturbCoincidentVertices.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPerturbCoincidentVertices(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPerturbCoincidentVertices_ClassNew(); }

#ifndef DECLARED_PyvtkGraphAlgorithm_ClassNew
extern "C" { PyObject *PyvtkGraphAlgorithm_ClassNew(); }
#define DECLARED_PyvtkGraphAlgorithm_ClassNew
#endif

static const char *PyvtkPerturbCoincidentVertices_Doc =
  "vtkPerturbCoincidentVertices - Perturbs vertices that are coincident.\n\n"
  "Superclass: vtkGraphAlgorithm\n\n"
  "This filter perturbs vertices in a graph that have coincident\n"
  "coordinates. In particular this happens all the time with graphs that\n"
  "are georeferenced, so we need a nice scheme to perturb the vertices\n"
  "so that when the user zooms in the vertices can be distiquished.\n\n";


static PyObject *
PyvtkPerturbCoincidentVertices_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPerturbCoincidentVertices::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPerturbCoincidentVertices_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPerturbCoincidentVertices *op = static_cast<vtkPerturbCoincidentVertices *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPerturbCoincidentVertices::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPerturbCoincidentVertices_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPerturbCoincidentVertices *tempr = vtkPerturbCoincidentVertices::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPerturbCoincidentVertices_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPerturbCoincidentVertices *op = static_cast<vtkPerturbCoincidentVertices *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPerturbCoincidentVertices *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPerturbCoincidentVertices::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPerturbCoincidentVertices_SetPerturbFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPerturbFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPerturbCoincidentVertices *op = static_cast<vtkPerturbCoincidentVertices *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPerturbFactor(temp0);
    }
    else
    {
      op->vtkPerturbCoincidentVertices::SetPerturbFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPerturbCoincidentVertices_GetPerturbFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPerturbFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPerturbCoincidentVertices *op = static_cast<vtkPerturbCoincidentVertices *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetPerturbFactor() :
      op->vtkPerturbCoincidentVertices::GetPerturbFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPerturbCoincidentVertices_Methods[] = {
  {"IsTypeOf", PyvtkPerturbCoincidentVertices_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPerturbCoincidentVertices_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPerturbCoincidentVertices_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPerturbCoincidentVertices\nC++: static vtkPerturbCoincidentVertices *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPerturbCoincidentVertices_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPerturbCoincidentVertices\nC++: vtkPerturbCoincidentVertices *NewInstance()\n\n"},
  {"SetPerturbFactor", PyvtkPerturbCoincidentVertices_SetPerturbFactor, METH_VARARGS,
   "V.SetPerturbFactor(float)\nC++: virtual void SetPerturbFactor(double _arg)\n\nSpecify the perturbation factor (defaults to 1.0)\n"},
  {"GetPerturbFactor", PyvtkPerturbCoincidentVertices_GetPerturbFactor, METH_VARARGS,
   "V.GetPerturbFactor() -> float\nC++: virtual double GetPerturbFactor()\n\nSpecify the perturbation factor (defaults to 1.0)\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPerturbCoincidentVertices_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInfovisLayoutPython.vtkPerturbCoincidentVertices", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPerturbCoincidentVertices_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPerturbCoincidentVertices_StaticNew()
{
  return vtkPerturbCoincidentVertices::New();
}

PyObject *PyvtkPerturbCoincidentVertices_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPerturbCoincidentVertices_Type, PyvtkPerturbCoincidentVertices_Methods,
    "vtkPerturbCoincidentVertices",
 &PyvtkPerturbCoincidentVertices_StaticNew);

  PyTypeObject *pytype = &PyvtkPerturbCoincidentVertices_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGraphAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPerturbCoincidentVertices(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPerturbCoincidentVertices_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPerturbCoincidentVertices", o) != 0)
  {
    Py_DECREF(o);
  }

}

